/*  
 *  LPT Manager
 *  Copyright (C) 2002  Giovanni Pardini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef FUNCTIONS_H
#define FUNCTIONS_H


#include <glib.h>
#include <gtk/gtk.h>


/* this struct holds some useful public variables */
struct
{
	GtkWidget *mainWnd;
	gint   	timeoutId;
} publicVars;


/* return a string describing the actual I/O functions type */
gchar *strIOFuncType(void);


/* Functions for port I/0 */

/* Try to get I/O permissions for the given address */
gint getPermissions(guint16 address);
/* Read a byte from address */
guint8 inbyte(guint16 address);
/* Write a byte to address */
void outbyte(guint16 address, guint8 val);
/* Invert the value of the bit at the address */
void invertBit(guint16 address, guint8 bitNum);
/* unused function */
/*void outBit(guint16 address, guint8 bitNum, gboolean value);*/


/* Functions for managing window */

/* Update window widgets reading current values from port */
gboolean updateWindow(void);
/* Set image of a bit */
gboolean updateBit (gchar *WidgetName, guint8 value, guint8 bit, GdkPixbuf *pix_on, GdkPixbuf *pix_off);
gboolean updateBit2(gchar *WidgetName, guint8 value, guint8 bit, GdkPixbuf *pix_on, GdkPixbuf *pix_off, gboolean swapImages);
/* Set sensitivity of all images on window */
void images_set_sensitive(gboolean sensitive);
/* Show modal Error Dialog */
void showErrorDlg(GtkWindow *transient, gchar *text);


#endif /* Not FUNCTIONS_H */
