/*  
 *  LPT Manager
 *  Copyright (C) 2002  Giovanni Pardini
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include "mainWnd.h"

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "lptmanager.h"
#include "mainWnd_cb.h"
#include "support.h"


GtkWidget*
create_mainWnd (void)
{

  GtkWidget *mainWnd;
  GtkWidget *vbox1;
  GtkWidget *menubar1;
  GtkWidget *menuitem1;
  GtkWidget *menuitem1_menu;
  GtkWidget *preferencesMnu;
  GtkWidget *image17;
  GtkWidget *separator1;
  GtkWidget *quitMnu;
  GtkWidget *image18;
  GtkWidget *menuitem4;
  GtkWidget *menuitem4_menu;
  GtkWidget *AboutMnu;
  GtkWidget *image19;
  GtkWidget *alignment2;
  GtkWidget *vbox2;
  GtkWidget *frame6;
  GtkWidget *hbox16;
  GtkWidget *label70;
  GtkWidget *monitoringTBtn;
  GtkWidget *vseparator22;
  GtkWidget *label71;
  GtkWidget *ModifyTBtn;
  GtkWidget *vseparator23;
  GtkWidget *label72;
  GtkWidget *showOpt;
  GtkWidget *menu1;
  GtkWidget *show_led_Mnu;
  GtkWidget *show_registry_Mnu;
  GtkWidget *label69;
  GtkWidget *hbox3;
  GtkWidget *frame1;
  GtkWidget *hbox5;
  GtkWidget *vbox3;
  GtkWidget *label3;
  GtkWidget *buttonP9;
  GtkWidget *imageP9;
  GtkWidget *label4;
  GtkWidget *vseparator1;
  GtkWidget *vbox4;
  GtkWidget *label5;
  GtkWidget *buttonP8;
  GtkWidget *imageP8;
  GtkWidget *label6;
  GtkWidget *vseparator2;
  GtkWidget *vbox5;
  GtkWidget *label7;
  GtkWidget *buttonP7;
  GtkWidget *imageP7;
  GtkWidget *label65;
  GtkWidget *vseparator3;
  GtkWidget *vbox6;
  GtkWidget *label9;
  GtkWidget *buttonP6;
  GtkWidget *imageP6;
  GtkWidget *label10;
  GtkWidget *vseparator4;
  GtkWidget *vbox7;
  GtkWidget *label11;
  GtkWidget *buttonP5;
  GtkWidget *imageP5;
  GtkWidget *label12;
  GtkWidget *vseparator5;
  GtkWidget *vbox8;
  GtkWidget *label13;
  GtkWidget *buttonP4;
  GtkWidget *imageP4;
  GtkWidget *label14;
  GtkWidget *vseparator6;
  GtkWidget *vbox9;
  GtkWidget *label15;
  GtkWidget *buttonP3;
  GtkWidget *imageP3;
  GtkWidget *label16;
  GtkWidget *vseparator7;
  GtkWidget *vbox10;
  GtkWidget *label17;
  GtkWidget *buttonP2;
  GtkWidget *imageP2;
  GtkWidget *label18;
  GtkWidget *vbox27;
  GtkWidget *addressBase0Lbl;
  GtkWidget *hbox10;
  GtkWidget *label58;
  GtkObject *DataPortValueSBtn_adj;
  GtkWidget *DataPortValueSBtn;
  GtkWidget *hbox6;
  GtkWidget *frame2;
  GtkWidget *hbox7;
  GtkWidget *vbox11;
  GtkWidget *label19;
  GtkWidget *imageP11;
  GtkWidget *label20;
  GtkWidget *vseparator8;
  GtkWidget *vbox12;
  GtkWidget *label21;
  GtkWidget *imageP10;
  GtkWidget *label22;
  GtkWidget *vseparator9;
  GtkWidget *vbox13;
  GtkWidget *label23;
  GtkWidget *imageP12;
  GtkWidget *label24;
  GtkWidget *vseparator10;
  GtkWidget *vbox14;
  GtkWidget *label25;
  GtkWidget *imageP13;
  GtkWidget *label26;
  GtkWidget *vseparator11;
  GtkWidget *vbox15;
  GtkWidget *label27;
  GtkWidget *imageP15;
  GtkWidget *label28;
  GtkWidget *vseparator12;
  GtkWidget *imageN1;
  GtkWidget *vseparator13;
  GtkWidget *imageN2;
  GtkWidget *vseparator14;
  GtkWidget *imageN3;
  GtkWidget *vbox28;
  GtkWidget *addressBase1Lbl;
  GtkWidget *hbox11;
  GtkWidget *label60;
  GtkWidget *StatusPortValueLbl;
  GtkWidget *hbox8;
  GtkWidget *frame3;
  GtkWidget *hbox9;
  GtkWidget *imageN4;
  GtkWidget *vseparator15;
  GtkWidget *imageN5;
  GtkWidget *vseparator16;
  GtkWidget *imageN6;
  GtkWidget *vseparator17;
  GtkWidget *vbox21;
  GtkWidget *label40;
  GtkWidget *buttonE;
  GtkWidget *imageE;
  GtkWidget *label41;
  GtkWidget *vseparator18;
  GtkWidget *vbox22;
  GtkWidget *label42;
  GtkWidget *buttonP17;
  GtkWidget *imageP17;
  GtkWidget *label43;
  GtkWidget *vseparator19;
  GtkWidget *vbox23;
  GtkWidget *label44;
  GtkWidget *buttonP16;
  GtkWidget *imageP16;
  GtkWidget *label45;
  GtkWidget *vseparator20;
  GtkWidget *vbox24;
  GtkWidget *label46;
  GtkWidget *buttonP14;
  GtkWidget *imageP14;
  GtkWidget *label47;
  GtkWidget *vseparator21;
  GtkWidget *vbox25;
  GtkWidget *label48;
  GtkWidget *buttonP1;
  GtkWidget *imageP1;
  GtkWidget *label49;
  GtkWidget *vbox29;
  GtkWidget *addressBase2Lbl;
  GtkWidget *hbox12;
  GtkWidget *label62;
  GtkObject *ControlPortValueSBtn_adj;
  GtkWidget *ControlPortValueSBtn;
  GtkWidget *hseparator1;
  GtkWidget *hbuttonbox2;
  GtkWidget *AboutBtn;
  GtkWidget *alignment1;
  GtkWidget *hbox2;
  GtkWidget *image1;
  GtkWidget *label1;
  GtkWidget *QuitBtn;
  GtkWidget *alignment3;
  GtkWidget *hbox17;
  GtkWidget *image22;
  GtkWidget *label78;

  mainWnd = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (mainWnd), 5);
  gtk_window_set_title (GTK_WINDOW (mainWnd), PROGRAM_NAME " " VERSION);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (mainWnd), vbox1);

  menubar1 = gtk_menu_bar_new ();
  gtk_widget_show (menubar1);
  gtk_box_pack_start (GTK_BOX (vbox1), menubar1, FALSE, FALSE, 0);

  menuitem1 = gtk_menu_item_new_with_mnemonic (_("_File"));
  gtk_widget_show (menuitem1);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem1);

  menuitem1_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem1), menuitem1_menu);

  preferencesMnu = gtk_image_menu_item_new_with_mnemonic (_("_Preferences..."));
  gtk_widget_show (preferencesMnu);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), preferencesMnu);

  image17 = gtk_image_new_from_stock ("gtk-preferences", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image17);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (preferencesMnu), image17);

  separator1 = gtk_menu_item_new ();
  gtk_widget_show (separator1);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), separator1);
  gtk_widget_set_sensitive (separator1, FALSE);

  quitMnu = gtk_image_menu_item_new_with_mnemonic (_("_Quit"));
  gtk_widget_show (quitMnu);
  gtk_container_add (GTK_CONTAINER (menuitem1_menu), quitMnu);

  image18 = gtk_image_new_from_stock ("gtk-quit", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image18);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (quitMnu), image18);

  menuitem4 = gtk_menu_item_new_with_mnemonic (_("_Help"));
  gtk_widget_show (menuitem4);
  gtk_container_add (GTK_CONTAINER (menubar1), menuitem4);

  menuitem4_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem4), menuitem4_menu);

  AboutMnu = gtk_image_menu_item_new_with_mnemonic (_("About..."));
  gtk_widget_show (AboutMnu);
  gtk_container_add (GTK_CONTAINER (menuitem4_menu), AboutMnu);

  image19 = gtk_image_new_from_stock ("gtk-dialog-info", GTK_ICON_SIZE_MENU);
  gtk_widget_show (image19);
  gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (AboutMnu), image19);

  alignment2 = gtk_alignment_new (0.5, 0.5, 0, 1);
  gtk_widget_show (alignment2);
  gtk_box_pack_start (GTK_BOX (vbox1), alignment2, TRUE, FALSE, 0);

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (alignment2), vbox2);

  frame6 = gtk_frame_new (NULL);
  gtk_widget_show (frame6);
  gtk_box_pack_start (GTK_BOX (vbox2), frame6, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame6), 5);

  hbox16 = gtk_hbox_new (FALSE, 5);
  gtk_widget_show (hbox16);
  gtk_container_add (GTK_CONTAINER (frame6), hbox16);
  gtk_container_set_border_width (GTK_CONTAINER (hbox16), 5);

  label70 = gtk_label_new (_("Monitoring:"));
  gtk_widget_show (label70);
  gtk_box_pack_start (GTK_BOX (hbox16), label70, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label70), GTK_JUSTIFY_LEFT);

  monitoringTBtn = gtk_toggle_button_new_with_mnemonic (_("INACTIVE"));
  gtk_widget_show (monitoringTBtn);
  gtk_box_pack_start (GTK_BOX (hbox16), monitoringTBtn, FALSE, FALSE, 0);
  gtk_widget_set_usize (monitoringTBtn, 75, -2);

  vseparator22 = gtk_vseparator_new ();
  gtk_widget_show (vseparator22);
  gtk_box_pack_start (GTK_BOX (hbox16), vseparator22, FALSE, FALSE, 0);

  label71 = gtk_label_new (_("Modify:"));
  gtk_widget_show (label71);
  gtk_box_pack_start (GTK_BOX (hbox16), label71, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label71), GTK_JUSTIFY_LEFT);

  ModifyTBtn = gtk_toggle_button_new_with_mnemonic (_("INACTIVE"));
  gtk_widget_show (ModifyTBtn);
  gtk_box_pack_start (GTK_BOX (hbox16), ModifyTBtn, FALSE, FALSE, 0);
  gtk_widget_set_usize (ModifyTBtn, 75, -2);

  vseparator23 = gtk_vseparator_new ();
  gtk_widget_show (vseparator23);
  gtk_box_pack_start (GTK_BOX (hbox16), vseparator23, FALSE, FALSE, 0);

  label72 = gtk_label_new (_("Show:"));
  gtk_widget_show (label72);
  gtk_box_pack_start (GTK_BOX (hbox16), label72, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label72), GTK_JUSTIFY_LEFT);

  showOpt = gtk_option_menu_new ();
  gtk_widget_show (showOpt);
  gtk_box_pack_start (GTK_BOX (hbox16), showOpt, FALSE, FALSE, 0);

  menu1 = gtk_menu_new ();

  show_led_Mnu = gtk_menu_item_new_with_mnemonic (_("LED"));
  gtk_widget_show (show_led_Mnu);
  gtk_container_add (GTK_CONTAINER (menu1), show_led_Mnu);

  show_registry_Mnu = gtk_menu_item_new_with_mnemonic (_("Registry"));
  gtk_widget_show (show_registry_Mnu);
  gtk_container_add (GTK_CONTAINER (menu1), show_registry_Mnu);

  gtk_option_menu_set_menu (GTK_OPTION_MENU (showOpt), menu1);

  label69 = gtk_label_new (_("Commands"));
  gtk_widget_show (label69);
  gtk_frame_set_label_widget (GTK_FRAME (frame6), label69);
  gtk_label_set_justify (GTK_LABEL (label69), GTK_JUSTIFY_LEFT);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox3, FALSE, TRUE, 0);

  frame1 = gtk_frame_new (NULL);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (hbox3), frame1, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 2);
  gtk_frame_set_shadow_type (GTK_FRAME (frame1), GTK_SHADOW_OUT);

  hbox5 = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (hbox5);
  gtk_container_add (GTK_CONTAINER (frame1), hbox5);
  gtk_container_set_border_width (GTK_CONTAINER (hbox5), 1);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox3, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox3, 65, -2);

  label3 = gtk_label_new ("D7");
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (vbox3), label3, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);

  buttonP9 = gtk_button_new ();
  gtk_widget_show (buttonP9);
  gtk_box_pack_start (GTK_BOX (vbox3), buttonP9, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP9), GTK_RELIEF_NONE);

  imageP9 = gtk_image_new ();
  gtk_widget_show (imageP9);
  gtk_container_add (GTK_CONTAINER (buttonP9), imageP9);
  gtk_widget_set_usize (imageP9, -2, 30);

  label4 = gtk_label_new ("pin 9");
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (vbox3), label4, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_show (vseparator1);
  gtk_box_pack_start (GTK_BOX (hbox5), vseparator1, FALSE, FALSE, 0);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox4, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox4, 65, -2);

  label5 = gtk_label_new ("D6");
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (vbox4), label5, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_LEFT);

  buttonP8 = gtk_button_new ();
  gtk_widget_show (buttonP8);
  gtk_box_pack_start (GTK_BOX (vbox4), buttonP8, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP8), GTK_RELIEF_NONE);

  imageP8 = gtk_image_new ();
  gtk_widget_show (imageP8);
  gtk_container_add (GTK_CONTAINER (buttonP8), imageP8);
  gtk_widget_set_usize (imageP8, -2, 30);

  label6 = gtk_label_new ("pin 8");
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (vbox4), label6, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_LEFT);

  vseparator2 = gtk_vseparator_new ();
  gtk_widget_show (vseparator2);
  gtk_box_pack_start (GTK_BOX (hbox5), vseparator2, FALSE, FALSE, 0);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox5, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox5, 65, -2);

  label7 = gtk_label_new ("D5");
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (vbox5), label7, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);

  buttonP7 = gtk_button_new ();
  gtk_widget_show (buttonP7);
  gtk_box_pack_start (GTK_BOX (vbox5), buttonP7, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP7), GTK_RELIEF_NONE);

  imageP7 = gtk_image_new ();
  gtk_widget_show (imageP7);
  gtk_container_add (GTK_CONTAINER (buttonP7), imageP7);
  gtk_widget_set_usize (imageP7, -2, 30);

  label65 = gtk_label_new ("pin 7");
  gtk_widget_show (label65);
  gtk_box_pack_start (GTK_BOX (vbox5), label65, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label65), GTK_JUSTIFY_LEFT);

  vseparator3 = gtk_vseparator_new ();
  gtk_widget_show (vseparator3);
  gtk_box_pack_start (GTK_BOX (hbox5), vseparator3, FALSE, FALSE, 0);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox6);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox6, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox6, 65, -2);

  label9 = gtk_label_new ("D4");
  gtk_widget_show (label9);
  gtk_box_pack_start (GTK_BOX (vbox6), label9, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label9), GTK_JUSTIFY_LEFT);

  buttonP6 = gtk_button_new ();
  gtk_widget_show (buttonP6);
  gtk_box_pack_start (GTK_BOX (vbox6), buttonP6, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP6), GTK_RELIEF_NONE);

  imageP6 = gtk_image_new ();
  gtk_widget_show (imageP6);
  gtk_container_add (GTK_CONTAINER (buttonP6), imageP6);
  gtk_widget_set_usize (imageP6, -2, 30);

  label10 = gtk_label_new ("pin 6");
  gtk_widget_show (label10);
  gtk_box_pack_start (GTK_BOX (vbox6), label10, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label10), GTK_JUSTIFY_LEFT);

  vseparator4 = gtk_vseparator_new ();
  gtk_widget_show (vseparator4);
  gtk_box_pack_start (GTK_BOX (hbox5), vseparator4, FALSE, FALSE, 0);

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox7);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox7, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox7, 65, -2);

  label11 = gtk_label_new ("D3");
  gtk_widget_show (label11);
  gtk_box_pack_start (GTK_BOX (vbox7), label11, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label11), GTK_JUSTIFY_LEFT);

  buttonP5 = gtk_button_new ();
  gtk_widget_show (buttonP5);
  gtk_box_pack_start (GTK_BOX (vbox7), buttonP5, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP5), GTK_RELIEF_NONE);

  imageP5 = gtk_image_new ();
  gtk_widget_show (imageP5);
  gtk_container_add (GTK_CONTAINER (buttonP5), imageP5);
  gtk_widget_set_usize (imageP5, -2, 30);

  label12 = gtk_label_new ("pin 5");
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (vbox7), label12, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label12), GTK_JUSTIFY_LEFT);

  vseparator5 = gtk_vseparator_new ();
  gtk_widget_show (vseparator5);
  gtk_box_pack_start (GTK_BOX (hbox5), vseparator5, FALSE, FALSE, 0);

  vbox8 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox8);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox8, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox8, 65, -2);

  label13 = gtk_label_new ("D2");
  gtk_widget_show (label13);
  gtk_box_pack_start (GTK_BOX (vbox8), label13, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label13), GTK_JUSTIFY_LEFT);

  buttonP4 = gtk_button_new ();
  gtk_widget_show (buttonP4);
  gtk_box_pack_start (GTK_BOX (vbox8), buttonP4, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP4), GTK_RELIEF_NONE);

  imageP4 = gtk_image_new ();
  gtk_widget_show (imageP4);
  gtk_container_add (GTK_CONTAINER (buttonP4), imageP4);
  gtk_widget_set_usize (imageP4, -2, 30);

  label14 = gtk_label_new ("pin 4");
  gtk_widget_show (label14);
  gtk_box_pack_start (GTK_BOX (vbox8), label14, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label14), GTK_JUSTIFY_LEFT);

  vseparator6 = gtk_vseparator_new ();
  gtk_widget_show (vseparator6);
  gtk_box_pack_start (GTK_BOX (hbox5), vseparator6, FALSE, FALSE, 0);

  vbox9 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox9);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox9, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox9, 65, -2);

  label15 = gtk_label_new ("D1");
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (vbox9), label15, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label15), GTK_JUSTIFY_LEFT);

  buttonP3 = gtk_button_new ();
  gtk_widget_show (buttonP3);
  gtk_box_pack_start (GTK_BOX (vbox9), buttonP3, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP3), GTK_RELIEF_NONE);

  imageP3 = gtk_image_new ();
  gtk_widget_show (imageP3);
  gtk_container_add (GTK_CONTAINER (buttonP3), imageP3);
  gtk_widget_set_usize (imageP3, -2, 30);

  label16 = gtk_label_new ("pin 3");
  gtk_widget_show (label16);
  gtk_box_pack_start (GTK_BOX (vbox9), label16, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label16), GTK_JUSTIFY_LEFT);

  vseparator7 = gtk_vseparator_new ();
  gtk_widget_show (vseparator7);
  gtk_box_pack_start (GTK_BOX (hbox5), vseparator7, FALSE, FALSE, 0);

  vbox10 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox10);
  gtk_box_pack_start (GTK_BOX (hbox5), vbox10, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox10, 65, -2);

  label17 = gtk_label_new ("D0");
  gtk_widget_show (label17);
  gtk_box_pack_start (GTK_BOX (vbox10), label17, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label17), GTK_JUSTIFY_LEFT);

  buttonP2 = gtk_button_new ();
  gtk_widget_show (buttonP2);
  gtk_box_pack_start (GTK_BOX (vbox10), buttonP2, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP2), GTK_RELIEF_NONE);

  imageP2 = gtk_image_new ();
  gtk_widget_show (imageP2);
  gtk_container_add (GTK_CONTAINER (buttonP2), imageP2);
  gtk_widget_set_usize (imageP2, -2, 30);

  label18 = gtk_label_new ("pin 2");
  gtk_widget_show (label18);
  gtk_box_pack_start (GTK_BOX (vbox10), label18, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label18), GTK_JUSTIFY_LEFT);

  vbox27 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox27);
  gtk_box_pack_start (GTK_BOX (hbox3), vbox27, FALSE, FALSE, 10);

  addressBase0Lbl = gtk_label_new (NULL);
  gtk_widget_show (addressBase0Lbl);
  gtk_box_pack_start (GTK_BOX (vbox27), addressBase0Lbl, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL(addressBase0Lbl), TRUE);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox27), hbox10, FALSE, FALSE, 0);

  label58 = gtk_label_new (_("Value: "));
  gtk_widget_show (label58);
  gtk_box_pack_start (GTK_BOX (hbox10), label58, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label58), GTK_JUSTIFY_LEFT);

  DataPortValueSBtn_adj = gtk_adjustment_new (0, 0, 255, 1, 10, 10);
  DataPortValueSBtn = gtk_spin_button_new (GTK_ADJUSTMENT (DataPortValueSBtn_adj), 1, 0);
  gtk_widget_show (DataPortValueSBtn);
  gtk_box_pack_start (GTK_BOX (hbox10), DataPortValueSBtn, TRUE, TRUE, 0);
  gtk_widget_set_usize (DataPortValueSBtn, 46, -2);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (DataPortValueSBtn), TRUE);
  gtk_spin_button_set_update_policy (GTK_SPIN_BUTTON (DataPortValueSBtn), GTK_UPDATE_IF_VALID);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox6, FALSE, FALSE, 0);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (hbox6), frame2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 2);
  gtk_frame_set_shadow_type (GTK_FRAME (frame2), GTK_SHADOW_OUT);

  hbox7 = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (hbox7);
  gtk_container_add (GTK_CONTAINER (frame2), hbox7);
  gtk_container_set_border_width (GTK_CONTAINER (hbox7), 1);

  vbox11 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox11);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox11, FALSE, TRUE, 0);
  gtk_widget_set_usize (vbox11, 65, -2);

  label19 = gtk_label_new ("BUSY");
  gtk_widget_show (label19);
  gtk_box_pack_start (GTK_BOX (vbox11), label19, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label19), GTK_JUSTIFY_LEFT);

  imageP11 = gtk_image_new ();
  gtk_widget_show (imageP11);
  gtk_box_pack_start (GTK_BOX (vbox11), imageP11, TRUE, TRUE, 0);
  gtk_widget_set_usize (imageP11, -2, 30);

  label20 = gtk_label_new ("pin 11");
  gtk_widget_show (label20);
  gtk_box_pack_start (GTK_BOX (vbox11), label20, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label20), GTK_JUSTIFY_LEFT);

  vseparator8 = gtk_vseparator_new ();
  gtk_widget_show (vseparator8);
  gtk_box_pack_start (GTK_BOX (hbox7), vseparator8, FALSE, FALSE, 0);

  vbox12 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox12);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox12, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox12, 65, -2);

  label21 = gtk_label_new ("ACK/");
  gtk_widget_show (label21);
  gtk_box_pack_start (GTK_BOX (vbox12), label21, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label21), GTK_JUSTIFY_LEFT);

  imageP10 = gtk_image_new ();
  gtk_widget_show (imageP10);
  gtk_box_pack_start (GTK_BOX (vbox12), imageP10, TRUE, TRUE, 0);
  gtk_widget_set_usize (imageP10, -2, 30);

  label22 = gtk_label_new ("pin 10");
  gtk_widget_show (label22);
  gtk_box_pack_start (GTK_BOX (vbox12), label22, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label22), GTK_JUSTIFY_LEFT);

  vseparator9 = gtk_vseparator_new ();
  gtk_widget_show (vseparator9);
  gtk_box_pack_start (GTK_BOX (hbox7), vseparator9, FALSE, FALSE, 0);

  vbox13 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox13);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox13, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox13, 65, -2);

  label23 = gtk_label_new ("PE");
  gtk_widget_show (label23);
  gtk_box_pack_start (GTK_BOX (vbox13), label23, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label23), GTK_JUSTIFY_LEFT);

  imageP12 = gtk_image_new ();
  gtk_widget_show (imageP12);
  gtk_box_pack_start (GTK_BOX (vbox13), imageP12, TRUE, TRUE, 0);
  gtk_widget_set_usize (imageP12, -2, 30);

  label24 = gtk_label_new ("pin 12");
  gtk_widget_show (label24);
  gtk_box_pack_start (GTK_BOX (vbox13), label24, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label24), GTK_JUSTIFY_LEFT);

  vseparator10 = gtk_vseparator_new ();
  gtk_widget_show (vseparator10);
  gtk_box_pack_start (GTK_BOX (hbox7), vseparator10, FALSE, FALSE, 0);

  vbox14 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox14);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox14, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox14, 65, -2);

  label25 = gtk_label_new ("SELECT");
  gtk_widget_show (label25);
  gtk_box_pack_start (GTK_BOX (vbox14), label25, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label25), GTK_JUSTIFY_LEFT);

  imageP13 = gtk_image_new ();
  gtk_widget_show (imageP13);
  gtk_box_pack_start (GTK_BOX (vbox14), imageP13, TRUE, TRUE, 0);
  gtk_widget_set_usize (imageP13, -2, 30);

  label26 = gtk_label_new ("pin 13");
  gtk_widget_show (label26);
  gtk_box_pack_start (GTK_BOX (vbox14), label26, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label26), GTK_JUSTIFY_LEFT);

  vseparator11 = gtk_vseparator_new ();
  gtk_widget_show (vseparator11);
  gtk_box_pack_start (GTK_BOX (hbox7), vseparator11, FALSE, FALSE, 0);

  vbox15 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox15);
  gtk_box_pack_start (GTK_BOX (hbox7), vbox15, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox15, 65, -2);

  label27 = gtk_label_new ("ERROR/");
  gtk_widget_show (label27);
  gtk_box_pack_start (GTK_BOX (vbox15), label27, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label27), GTK_JUSTIFY_LEFT);

  imageP15 = gtk_image_new ();
  gtk_widget_show (imageP15);
  gtk_box_pack_start (GTK_BOX (vbox15), imageP15, TRUE, TRUE, 0);
  gtk_widget_set_usize (imageP15, -2, 30);

  label28 = gtk_label_new ("pin 15");
  gtk_widget_show (label28);
  gtk_box_pack_start (GTK_BOX (vbox15), label28, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label28), GTK_JUSTIFY_LEFT);

  vseparator12 = gtk_vseparator_new ();
  gtk_widget_show (vseparator12);
  gtk_box_pack_start (GTK_BOX (hbox7), vseparator12, FALSE, FALSE, 0);

  imageN1 = gtk_image_new ();
  gtk_widget_show (imageN1);
  gtk_box_pack_start (GTK_BOX (hbox7), imageN1, FALSE, FALSE, 0);
  gtk_widget_set_usize (imageN1, 65, 30);

  vseparator13 = gtk_vseparator_new ();
  gtk_widget_show (vseparator13);
  gtk_box_pack_start (GTK_BOX (hbox7), vseparator13, FALSE, FALSE, 0);

  imageN2 = gtk_image_new ();
  gtk_widget_show (imageN2);
  gtk_box_pack_start (GTK_BOX (hbox7), imageN2, FALSE, FALSE, 0);
  gtk_widget_set_usize (imageN2, 65, 30);

  vseparator14 = gtk_vseparator_new ();
  gtk_widget_show (vseparator14);
  gtk_box_pack_start (GTK_BOX (hbox7), vseparator14, FALSE, FALSE, 0);

  imageN3 = gtk_image_new ();
  gtk_widget_show (imageN3);
  gtk_box_pack_start (GTK_BOX (hbox7), imageN3, FALSE, FALSE, 0);
  gtk_widget_set_usize (imageN3, 65, 30);

  vbox28 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox28);
  gtk_box_pack_start (GTK_BOX (hbox6), vbox28, FALSE, FALSE, 10);

  addressBase1Lbl = gtk_label_new (NULL);
  gtk_widget_show (addressBase1Lbl);
  gtk_box_pack_start (GTK_BOX (vbox28), addressBase1Lbl, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL(addressBase1Lbl), TRUE);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox11);
  gtk_box_pack_start (GTK_BOX (vbox28), hbox11, FALSE, FALSE, 0);

  label60 = gtk_label_new (_("Value: "));
  gtk_widget_show (label60);
  gtk_box_pack_start (GTK_BOX (hbox11), label60, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label60), GTK_JUSTIFY_LEFT);

  StatusPortValueLbl = gtk_label_new (NULL);
  gtk_widget_show (StatusPortValueLbl);
  gtk_box_pack_start (GTK_BOX (hbox11), StatusPortValueLbl, FALSE, FALSE, 0);
  gtk_widget_set_usize (StatusPortValueLbl, 46, -2);
  GTK_WIDGET_SET_FLAGS (StatusPortValueLbl, GTK_CAN_FOCUS);
  gtk_label_set_justify (GTK_LABEL (StatusPortValueLbl), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (StatusPortValueLbl), TRUE);
  gtk_label_set_selectable (GTK_LABEL (StatusPortValueLbl), TRUE);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox8, FALSE, FALSE, 0);

  frame3 = gtk_frame_new (NULL);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (hbox8), frame3, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame3), 2);
  gtk_frame_set_shadow_type (GTK_FRAME (frame3), GTK_SHADOW_OUT);

  hbox9 = gtk_hbox_new (FALSE, 1);
  gtk_widget_show (hbox9);
  gtk_container_add (GTK_CONTAINER (frame3), hbox9);
  gtk_container_set_border_width (GTK_CONTAINER (hbox9), 1);

  imageN4 = gtk_image_new ();
  gtk_widget_show (imageN4);
  gtk_box_pack_start (GTK_BOX (hbox9), imageN4, FALSE, TRUE, 0);
  gtk_widget_set_usize (imageN4, 65, 30);

  vseparator15 = gtk_vseparator_new ();
  gtk_widget_show (vseparator15);
  gtk_box_pack_start (GTK_BOX (hbox9), vseparator15, FALSE, FALSE, 0);

  imageN5 = gtk_image_new ();
  gtk_widget_show (imageN5);
  gtk_box_pack_start (GTK_BOX (hbox9), imageN5, FALSE, FALSE, 0);
  gtk_widget_set_usize (imageN5, 65, 30);

  vseparator16 = gtk_vseparator_new ();
  gtk_widget_show (vseparator16);
  gtk_box_pack_start (GTK_BOX (hbox9), vseparator16, FALSE, FALSE, 0);

  imageN6 = gtk_image_new ();
  gtk_widget_show (imageN6);
  gtk_box_pack_start (GTK_BOX (hbox9), imageN6, FALSE, FALSE, 0);
  gtk_widget_set_usize (imageN6, 65, 30);

  vseparator17 = gtk_vseparator_new ();
  gtk_widget_show (vseparator17);
  gtk_box_pack_start (GTK_BOX (hbox9), vseparator17, FALSE, FALSE, 0);

  vbox21 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox21);
  gtk_box_pack_start (GTK_BOX (hbox9), vbox21, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox21, 65, -2);

  label40 = gtk_label_new ("ENABLE");
  gtk_widget_show (label40);
  gtk_box_pack_start (GTK_BOX (vbox21), label40, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label40), GTK_JUSTIFY_LEFT);

  buttonE = gtk_button_new ();
  gtk_widget_show (buttonE);
  gtk_box_pack_start (GTK_BOX (vbox21), buttonE, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonE), GTK_RELIEF_NONE);

  imageE = gtk_image_new ();
  gtk_widget_show (imageE);
  gtk_container_add (GTK_CONTAINER (buttonE), imageE);
  gtk_widget_set_usize (imageE, -2, 30);

  label41 = gtk_label_new ("-");
  gtk_widget_show (label41);
  gtk_box_pack_start (GTK_BOX (vbox21), label41, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label41), GTK_JUSTIFY_LEFT);

  vseparator18 = gtk_vseparator_new ();
  gtk_widget_show (vseparator18);
  gtk_box_pack_start (GTK_BOX (hbox9), vseparator18, FALSE, FALSE, 0);

  vbox22 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox22);
  gtk_box_pack_start (GTK_BOX (hbox9), vbox22, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox22, 65, -2);

  label42 = gtk_label_new ("SINP/");
  gtk_widget_show (label42);
  gtk_box_pack_start (GTK_BOX (vbox22), label42, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label42), GTK_JUSTIFY_LEFT);

  buttonP17 = gtk_button_new ();
  gtk_widget_show (buttonP17);
  gtk_box_pack_start (GTK_BOX (vbox22), buttonP17, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP17), GTK_RELIEF_NONE);

  imageP17 = gtk_image_new ();
  gtk_widget_show (imageP17);
  gtk_container_add (GTK_CONTAINER (buttonP17), imageP17);
  gtk_widget_set_usize (imageP17, -2, 30);

  label43 = gtk_label_new ("pin 17");
  gtk_widget_show (label43);
  gtk_box_pack_start (GTK_BOX (vbox22), label43, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label43), GTK_JUSTIFY_LEFT);

  vseparator19 = gtk_vseparator_new ();
  gtk_widget_show (vseparator19);
  gtk_box_pack_start (GTK_BOX (hbox9), vseparator19, FALSE, FALSE, 0);

  vbox23 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox23);
  gtk_box_pack_start (GTK_BOX (hbox9), vbox23, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox23, 65, -2);

  label44 = gtk_label_new ("INIT/");
  gtk_widget_show (label44);
  gtk_box_pack_start (GTK_BOX (vbox23), label44, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label44), GTK_JUSTIFY_LEFT);

  buttonP16 = gtk_button_new ();
  gtk_widget_show (buttonP16);
  gtk_box_pack_start (GTK_BOX (vbox23), buttonP16, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP16), GTK_RELIEF_NONE);

  imageP16 = gtk_image_new ();
  gtk_widget_show (imageP16);
  gtk_container_add (GTK_CONTAINER (buttonP16), imageP16);
  gtk_widget_set_usize (imageP16, -2, 30);

  label45 = gtk_label_new ("pin 16");
  gtk_widget_show (label45);
  gtk_box_pack_start (GTK_BOX (vbox23), label45, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label45), GTK_JUSTIFY_LEFT);

  vseparator20 = gtk_vseparator_new ();
  gtk_widget_show (vseparator20);
  gtk_box_pack_start (GTK_BOX (hbox9), vseparator20, FALSE, FALSE, 0);

  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox24);
  gtk_box_pack_start (GTK_BOX (hbox9), vbox24, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox24, 65, -2);

  label46 = gtk_label_new ("FEED/");
  gtk_widget_show (label46);
  gtk_box_pack_start (GTK_BOX (vbox24), label46, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label46), GTK_JUSTIFY_LEFT);

  buttonP14 = gtk_button_new ();
  gtk_widget_show (buttonP14);
  gtk_box_pack_start (GTK_BOX (vbox24), buttonP14, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP14), GTK_RELIEF_NONE);

  imageP14 = gtk_image_new ();
  gtk_widget_show (imageP14);
  gtk_container_add (GTK_CONTAINER (buttonP14), imageP14);
  gtk_widget_set_usize (imageP14, -2, 30);

  label47 = gtk_label_new ("pin 14");
  gtk_widget_show (label47);
  gtk_box_pack_start (GTK_BOX (vbox24), label47, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label47), GTK_JUSTIFY_LEFT);

  vseparator21 = gtk_vseparator_new ();
  gtk_widget_show (vseparator21);
  gtk_box_pack_start (GTK_BOX (hbox9), vseparator21, FALSE, FALSE, 0);

  vbox25 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox25);
  gtk_box_pack_start (GTK_BOX (hbox9), vbox25, FALSE, FALSE, 0);
  gtk_widget_set_usize (vbox25, 65, -2);

  label48 = gtk_label_new ("STRBE/");
  gtk_widget_show (label48);
  gtk_box_pack_start (GTK_BOX (vbox25), label48, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label48), GTK_JUSTIFY_LEFT);

  buttonP1 = gtk_button_new ();
  gtk_widget_show (buttonP1);
  gtk_box_pack_start (GTK_BOX (vbox25), buttonP1, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (buttonP1), GTK_RELIEF_NONE);

  imageP1 = gtk_image_new ();
  gtk_widget_show (imageP1);
  gtk_container_add (GTK_CONTAINER (buttonP1), imageP1);
  gtk_widget_set_usize (imageP1, -2, 30);

  label49 = gtk_label_new ("pin 1");
  gtk_widget_show (label49);
  gtk_box_pack_start (GTK_BOX (vbox25), label49, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label49), GTK_JUSTIFY_LEFT);

  vbox29 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox29);
  gtk_box_pack_start (GTK_BOX (hbox8), vbox29, FALSE, FALSE, 10);

  addressBase2Lbl = gtk_label_new (NULL);
  gtk_widget_show (addressBase2Lbl);
  gtk_box_pack_start (GTK_BOX (vbox29), addressBase2Lbl, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL(addressBase2Lbl), TRUE);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox29), hbox12, FALSE, FALSE, 0);

  label62 = gtk_label_new (_("Value: "));
  gtk_widget_show (label62);
  gtk_box_pack_start (GTK_BOX (hbox12), label62, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label62), GTK_JUSTIFY_LEFT);

  ControlPortValueSBtn_adj = gtk_adjustment_new (0, 0, 31, 1, 10, 10);
  ControlPortValueSBtn = gtk_spin_button_new (GTK_ADJUSTMENT (ControlPortValueSBtn_adj), 1, 0);
  gtk_widget_show (ControlPortValueSBtn);
  gtk_box_pack_start (GTK_BOX (hbox12), ControlPortValueSBtn, TRUE, TRUE, 0);
  gtk_widget_set_usize (ControlPortValueSBtn, 46, -2);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (ControlPortValueSBtn), TRUE);
  gtk_spin_button_set_update_policy (GTK_SPIN_BUTTON (ControlPortValueSBtn), GTK_UPDATE_IF_VALID);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, FALSE, 2);

  hbuttonbox2 = gtk_hbutton_box_new ();
  gtk_widget_show (hbuttonbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbuttonbox2, FALSE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox2), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox2), 10);

  AboutBtn = gtk_button_new ();
  gtk_widget_show (AboutBtn);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), AboutBtn);
  GTK_WIDGET_SET_FLAGS (AboutBtn, GTK_CAN_DEFAULT);

  alignment1 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment1);
  gtk_container_add (GTK_CONTAINER (AboutBtn), alignment1);

  hbox2 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox2);
  gtk_container_add (GTK_CONTAINER (alignment1), hbox2);

  image1 = gtk_image_new_from_stock ("gtk-dialog-info", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image1);
  gtk_box_pack_start (GTK_BOX (hbox2), image1, FALSE, FALSE, 0);

  label1 = gtk_label_new_with_mnemonic (_("_About..."));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox2), label1, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);

  QuitBtn = gtk_button_new ();
  gtk_widget_show (QuitBtn);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), QuitBtn);
  GTK_WIDGET_SET_FLAGS (QuitBtn, GTK_CAN_DEFAULT);

  alignment3 = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_widget_show (alignment3);
  gtk_container_add (GTK_CONTAINER (QuitBtn), alignment3);

  hbox17 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox17);
  gtk_container_add (GTK_CONTAINER (alignment3), hbox17);

  image22 = gtk_image_new_from_stock ("gtk-quit", GTK_ICON_SIZE_BUTTON);
  gtk_widget_show (image22);
  gtk_box_pack_start (GTK_BOX (hbox17), image22, FALSE, FALSE, 0);

  label78 = gtk_label_new_with_mnemonic (_("_Quit"));
  gtk_widget_show (label78);
  gtk_box_pack_start (GTK_BOX (hbox17), label78, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label78), GTK_JUSTIFY_LEFT);

  gtk_signal_connect (GTK_OBJECT (mainWnd), "destroy",
                      GTK_SIGNAL_FUNC (on_mainWnd_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (preferencesMnu), "activate",
                      GTK_SIGNAL_FUNC (on_preferencesMnu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (quitMnu), "activate",
                      GTK_SIGNAL_FUNC (on_quitMnu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (AboutMnu), "activate",
                      GTK_SIGNAL_FUNC (on_AboutMnu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (monitoringTBtn), "toggled",
                      GTK_SIGNAL_FUNC (on_monitoringTBtn_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ModifyTBtn), "toggled",
                      GTK_SIGNAL_FUNC (on_ModifyTBtn_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (show_led_Mnu), "activate",
                      GTK_SIGNAL_FUNC (on_show_led_Mnu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (show_registry_Mnu), "activate",
                      GTK_SIGNAL_FUNC (on_show_registry_Mnu_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP9), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP9_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP8), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP8_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP7), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP7_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP6), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP6_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP5), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP5_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP4), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP4_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP3), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP3_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP2), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP2_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (DataPortValueSBtn), "value_changed",
                      GTK_SIGNAL_FUNC (on_DataPortValueSBtn_value_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonE), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonE_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP17), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP17_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP16), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP16_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP14), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP14_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (buttonP1), "clicked",
                      GTK_SIGNAL_FUNC (on_buttonP1_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ControlPortValueSBtn), "value_changed",
                      GTK_SIGNAL_FUNC (on_ControlPortValueSBtn_value_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (AboutBtn), "clicked",
                      GTK_SIGNAL_FUNC (on_AboutBtn_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (QuitBtn), "clicked",
                      GTK_SIGNAL_FUNC (on_QuitBtn_clicked),
                      NULL);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (mainWnd, mainWnd, "mainWnd");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox1, "vbox1");
  GLADE_HOOKUP_OBJECT (mainWnd, menubar1, "menubar1");
  GLADE_HOOKUP_OBJECT (mainWnd, menuitem1, "menuitem1");
  GLADE_HOOKUP_OBJECT (mainWnd, menuitem1_menu, "menuitem1_menu");
  GLADE_HOOKUP_OBJECT (mainWnd, preferencesMnu, "preferencesMnu");
  GLADE_HOOKUP_OBJECT (mainWnd, image17, "image17");
  GLADE_HOOKUP_OBJECT (mainWnd, separator1, "separator1");
  GLADE_HOOKUP_OBJECT (mainWnd, quitMnu, "quitMnu");
  GLADE_HOOKUP_OBJECT (mainWnd, image18, "image18");
  GLADE_HOOKUP_OBJECT (mainWnd, menuitem4, "menuitem4");
  GLADE_HOOKUP_OBJECT (mainWnd, menuitem4_menu, "menuitem4_menu");
  GLADE_HOOKUP_OBJECT (mainWnd, AboutMnu, "AboutMnu");
  GLADE_HOOKUP_OBJECT (mainWnd, image19, "image19");
  GLADE_HOOKUP_OBJECT (mainWnd, alignment2, "alignment2");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox2, "vbox2");
  GLADE_HOOKUP_OBJECT (mainWnd, frame6, "frame6");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox16, "hbox16");
  GLADE_HOOKUP_OBJECT (mainWnd, label70, "label70");
  GLADE_HOOKUP_OBJECT (mainWnd, monitoringTBtn, "monitoringTBtn");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator22, "vseparator22");
  GLADE_HOOKUP_OBJECT (mainWnd, label71, "label71");
  GLADE_HOOKUP_OBJECT (mainWnd, ModifyTBtn, "ModifyTBtn");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator23, "vseparator23");
  GLADE_HOOKUP_OBJECT (mainWnd, label72, "label72");
  GLADE_HOOKUP_OBJECT (mainWnd, showOpt, "showOpt");
  GLADE_HOOKUP_OBJECT (mainWnd, menu1, "menu1");
  GLADE_HOOKUP_OBJECT (mainWnd, show_led_Mnu, "show_led_Mnu");
  GLADE_HOOKUP_OBJECT (mainWnd, show_registry_Mnu, "show_registry_Mnu");
  GLADE_HOOKUP_OBJECT (mainWnd, label69, "label69");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox3, "hbox3");
  GLADE_HOOKUP_OBJECT (mainWnd, frame1, "frame1");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox5, "hbox5");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox3, "vbox3");
  GLADE_HOOKUP_OBJECT (mainWnd, label3, "label3");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP9, "buttonP9");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP9, "imageP9");
  GLADE_HOOKUP_OBJECT (mainWnd, label4, "label4");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator1, "vseparator1");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox4, "vbox4");
  GLADE_HOOKUP_OBJECT (mainWnd, label5, "label5");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP8, "buttonP8");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP8, "imageP8");
  GLADE_HOOKUP_OBJECT (mainWnd, label6, "label6");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator2, "vseparator2");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox5, "vbox5");
  GLADE_HOOKUP_OBJECT (mainWnd, label7, "label7");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP7, "buttonP7");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP7, "imageP7");
  GLADE_HOOKUP_OBJECT (mainWnd, label65, "label65");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator3, "vseparator3");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox6, "vbox6");
  GLADE_HOOKUP_OBJECT (mainWnd, label9, "label9");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP6, "buttonP6");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP6, "imageP6");
  GLADE_HOOKUP_OBJECT (mainWnd, label10, "label10");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator4, "vseparator4");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox7, "vbox7");
  GLADE_HOOKUP_OBJECT (mainWnd, label11, "label11");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP5, "buttonP5");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP5, "imageP5");
  GLADE_HOOKUP_OBJECT (mainWnd, label12, "label12");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator5, "vseparator5");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox8, "vbox8");
  GLADE_HOOKUP_OBJECT (mainWnd, label13, "label13");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP4, "buttonP4");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP4, "imageP4");
  GLADE_HOOKUP_OBJECT (mainWnd, label14, "label14");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator6, "vseparator6");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox9, "vbox9");
  GLADE_HOOKUP_OBJECT (mainWnd, label15, "label15");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP3, "buttonP3");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP3, "imageP3");
  GLADE_HOOKUP_OBJECT (mainWnd, label16, "label16");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator7, "vseparator7");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox10, "vbox10");
  GLADE_HOOKUP_OBJECT (mainWnd, label17, "label17");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP2, "buttonP2");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP2, "imageP2");
  GLADE_HOOKUP_OBJECT (mainWnd, label18, "label18");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox27, "vbox27");
  GLADE_HOOKUP_OBJECT (mainWnd, addressBase0Lbl, "addressBase0Lbl");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox10, "hbox10");
  GLADE_HOOKUP_OBJECT (mainWnd, label58, "label58");
  GLADE_HOOKUP_OBJECT (mainWnd, DataPortValueSBtn, "DataPortValueSBtn");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox6, "hbox6");
  GLADE_HOOKUP_OBJECT (mainWnd, frame2, "frame2");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox7, "hbox7");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox11, "vbox11");
  GLADE_HOOKUP_OBJECT (mainWnd, label19, "label19");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP11, "imageP11");
  GLADE_HOOKUP_OBJECT (mainWnd, label20, "label20");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator8, "vseparator8");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox12, "vbox12");
  GLADE_HOOKUP_OBJECT (mainWnd, label21, "label21");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP10, "imageP10");
  GLADE_HOOKUP_OBJECT (mainWnd, label22, "label22");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator9, "vseparator9");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox13, "vbox13");
  GLADE_HOOKUP_OBJECT (mainWnd, label23, "label23");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP12, "imageP12");
  GLADE_HOOKUP_OBJECT (mainWnd, label24, "label24");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator10, "vseparator10");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox14, "vbox14");
  GLADE_HOOKUP_OBJECT (mainWnd, label25, "label25");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP13, "imageP13");
  GLADE_HOOKUP_OBJECT (mainWnd, label26, "label26");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator11, "vseparator11");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox15, "vbox15");
  GLADE_HOOKUP_OBJECT (mainWnd, label27, "label27");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP15, "imageP15");
  GLADE_HOOKUP_OBJECT (mainWnd, label28, "label28");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator12, "vseparator12");
  GLADE_HOOKUP_OBJECT (mainWnd, imageN1, "imageN1");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator13, "vseparator13");
  GLADE_HOOKUP_OBJECT (mainWnd, imageN2, "imageN2");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator14, "vseparator14");
  GLADE_HOOKUP_OBJECT (mainWnd, imageN3, "imageN3");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox28, "vbox28");
  GLADE_HOOKUP_OBJECT (mainWnd, addressBase1Lbl, "addressBase1Lbl");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox11, "hbox11");
  GLADE_HOOKUP_OBJECT (mainWnd, label60, "label60");
  GLADE_HOOKUP_OBJECT (mainWnd, StatusPortValueLbl, "StatusPortValueLbl");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox8, "hbox8");
  GLADE_HOOKUP_OBJECT (mainWnd, frame3, "frame3");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox9, "hbox9");
  GLADE_HOOKUP_OBJECT (mainWnd, imageN4, "imageN4");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator15, "vseparator15");
  GLADE_HOOKUP_OBJECT (mainWnd, imageN5, "imageN5");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator16, "vseparator16");
  GLADE_HOOKUP_OBJECT (mainWnd, imageN6, "imageN6");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator17, "vseparator17");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox21, "vbox21");
  GLADE_HOOKUP_OBJECT (mainWnd, label40, "label40");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonE, "buttonE");
  GLADE_HOOKUP_OBJECT (mainWnd, imageE, "imageE");
  GLADE_HOOKUP_OBJECT (mainWnd, label41, "label41");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator18, "vseparator18");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox22, "vbox22");
  GLADE_HOOKUP_OBJECT (mainWnd, label42, "label42");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP17, "buttonP17");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP17, "imageP17");
  GLADE_HOOKUP_OBJECT (mainWnd, label43, "label43");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator19, "vseparator19");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox23, "vbox23");
  GLADE_HOOKUP_OBJECT (mainWnd, label44, "label44");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP16, "buttonP16");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP16, "imageP16");
  GLADE_HOOKUP_OBJECT (mainWnd, label45, "label45");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator20, "vseparator20");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox24, "vbox24");
  GLADE_HOOKUP_OBJECT (mainWnd, label46, "label46");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP14, "buttonP14");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP14, "imageP14");
  GLADE_HOOKUP_OBJECT (mainWnd, label47, "label47");
  GLADE_HOOKUP_OBJECT (mainWnd, vseparator21, "vseparator21");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox25, "vbox25");
  GLADE_HOOKUP_OBJECT (mainWnd, label48, "label48");
  GLADE_HOOKUP_OBJECT (mainWnd, buttonP1, "buttonP1");
  GLADE_HOOKUP_OBJECT (mainWnd, imageP1, "imageP1");
  GLADE_HOOKUP_OBJECT (mainWnd, label49, "label49");
  GLADE_HOOKUP_OBJECT (mainWnd, vbox29, "vbox29");
  GLADE_HOOKUP_OBJECT (mainWnd, addressBase2Lbl, "addressBase2Lbl");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox12, "hbox12");
  GLADE_HOOKUP_OBJECT (mainWnd, label62, "label62");
  GLADE_HOOKUP_OBJECT (mainWnd, ControlPortValueSBtn, "ControlPortValueSBtn");
  GLADE_HOOKUP_OBJECT (mainWnd, hseparator1, "hseparator1");
  GLADE_HOOKUP_OBJECT (mainWnd, hbuttonbox2, "hbuttonbox2");
  GLADE_HOOKUP_OBJECT (mainWnd, AboutBtn, "AboutBtn");
  GLADE_HOOKUP_OBJECT (mainWnd, alignment1, "alignment1");
  GLADE_HOOKUP_OBJECT (mainWnd, hbox2, "hbox2");
  GLADE_HOOKUP_OBJECT (mainWnd, image1, "image1");
  GLADE_HOOKUP_OBJECT (mainWnd, label1, "label1");
  GLADE_HOOKUP_OBJECT (mainWnd, QuitBtn, "QuitBtn");

  gtk_widget_grab_focus (QuitBtn);
  gtk_widget_grab_default (QuitBtn);
  return mainWnd;
}
