; Giovanni Pardini <gpardini@users.sourceforge.net>
;
; The GTK+ stuff is taken from http://www.dropline.net/gtk/downloads/gtk-sample.iss
; written by Todd Kulesza <todd@dropline.net>.

[Setup]
AppName=LPT Manager
AppVerName=LPT Manager 1.1
AppPublisher=Giovanni Pardini
AppPublisherURL=http://lptman.sourceforge.net
AppSupportURL=http://lptman.sourceforge.net
AppUpdatesURL=http://lptman.sourceforge.net
DefaultDirName={pf}\LPT Manager
DefaultGroupName=LPT Manager
LicenseFile=F:\lptmanager-1.1\COPYING
SourceDir=F:\lptmanager-1.1
OutputDir=F:\lptmanager-1.1\win_setup
OutputBaseFilename=lptmanager-1.1


[Tasks]
Name: "desktopicon"; Description: "Create a &desktop icon"; GroupDescription: "Additional icons:"


[Files]
Source: "src\lptman.exe"; DestDir: "{app}"; Flags: ignoreversion
Source: "po\it.mo"; DestDir: "{app}\locale\it\LC_MESSAGES"; DestName: "lptmanager.mo"; Flags: ignoreversion
Source: "win_setup\iodll\io.dll"; DestDir: "{app}"; Flags: ignoreversion


[Registry]
Root: HKCU; SubKey: "Software\LPT Manager\1.1"; Flags: uninsdeletekey
Root: HKCU; SubKey: "Software\LPT Manager"; Flags: uninsdeletekeyifempty

; This adds the GTK+ libraries to gtk-foo.exe's path
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\lptman.exe"; Flags: uninsdeletekeyifempty
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\lptman.exe"; ValueType: string; ValueData: "{app}\lptman.exe"; Flags: uninsdeletevalue
Root: HKLM; Subkey: "Software\Microsoft\Windows\CurrentVersion\App Paths\lptman.exe"; ValueType: string; ValueName: "Path"; ValueData: "{app};{code:GetGtkPath}\lib"; Flags: uninsdeletevalue


[INI]
Filename: "{app}\lptman.url"; Section: "InternetShortcut"; Key: "URL"; String: "http://lptman.sourceforge.net"


[Icons]
Name: "{group}\LPT Manager"; Filename: "{app}\lptman.exe"
Name: "{group}\LPT Manager on the Web"; Filename: "{app}\lptman.url"
Name: "{group}\Uninstall LPT Manager"; Filename: "{uninstallexe}"
Name: "{userdesktop}\LPT Manager"; Filename: "{app}\lptman.exe"; Tasks: desktopicon


[Run]
Filename: "{app}\lptman.exe"; Description: "Launch LPT Manager"; Flags: nowait


[UninstallDelete]
Type: files; Name: "{app}\lptman.url"


[Code]

var
  Exists: Boolean;
  GtkPath: String;

function GetGtkInstalled (): Boolean;
begin
  Exists := RegQueryStringValue (HKLM, 'Software\GTK\2.0', 'Path', GtkPath);
  if not Exists then begin
    Exists := RegQueryStringValue (HKCU, 'Software\GTK\2.0', 'Path', GtkPath);
  end;
   Result := Exists
end;

function GetGtkPath (S: String): String;
begin
    Result := GtkPath;
end;

function InitializeSetup(): Boolean;
begin
  Result := GetGtkInstalled ();
  if not Result then begin
    MsgBox ('Please install the GTK+ 2.0 Runtime Environment before installing LPT Manager. You can obtain GTK+ from http://www2.arnes.si/~sopjsimo/gimp', mbError, MB_OK);
  end;
end;
